//
//  ImageFilter.java
//  
//
//  Created by David King on 3/21/10.
//  Copyright 2010 Miguel A. Carreira-Perpinan. All rights reserved.
//

//These imports are for anything extending FileFilter
import java.io.File;
import javax.swing.filechooser.*;

public class ImageFilter extends FileFilter
{
	//This string lists the extensions we approve of
	private final String[] okFileExtensions = 
		new String[] {"jpg", "jpeg", "png", "gif", "bmp"};

	public boolean accept(File file)
	{
		//We can navigate folders
		if (file.isDirectory())
			return true;
		
		//This compares if files are good to use
		for (String extension : okFileExtensions)
			if (file.getName().toLowerCase().endsWith(extension))
				return true;
		//This returns false if nothing is approved
		return false;
	}
  
	public String getDescription()
	{
		//This is what our filter is called
		return "Images";
	}

}
