//
//  concomp2.java
//  
//
//  Created by David King on 5/6/10.
//	Edited by Mark Crompton and Jimmy Yih on 5/17/11
//  Copyright 2010 Miguel A. Carreira-Perpinan. All rights reserved.
//

import java.util.*;

public class concomp {
	int K;
	int [] compl;
	
	concomp(double [][] X,double min_diff)
	{
		int N = X.length;
		int D = X[0].length;
		compl = new int[N]; //Label of each pixel
		
		int label = 0; //This will determine which label to label our indexes

		/** New implementation which will run O(kN) where N = number of pixels and k = number of centroids
		*	@centroids - list of centroids
		*	@labels - parallel to centroids which carries the label of the parallel centroid
		*	@trig - trigger/flag that tells us if a new centroid is needed
		*/
		ArrayList<Integer> centroids = new ArrayList<Integer>();
		ArrayList<Integer> labels = new ArrayList<Integer>();
		for (int i = 0; i < N; i++) {
			boolean trig = true;
			int count = 0;
			for (int j : centroids) {
				double temp = 0.0f;
				for(int k = 0; k < D; k++) {
					temp += (double) Math.pow(X[j][k] - X[i][k],2);
				}
				temp = (double) Math.sqrt(temp);

				if(temp <= min_diff) {
					compl[i] = labels.get(count);
					trig = false;
					break;
				}
				count++;
			}
			
			if (trig) {
				centroids.add(0, i);
				labels.add(0, label);
				compl[i] = label;
				label++;
			}
		}

		K = label;
	}
	
	void setLabels(int [] Labels)
	{
		compl = new int[Labels.length];
		for(int i=0;i<compl.length;i++)
			compl[i] = Labels[i];
	}
}
